---
title: RTCIceCandidate.usernameFragment
slug: Web/API/RTCIceCandidate/usernameFragment
tags:
  - API
  - Candidate
  - NeedsExample
  - Property
  - RTCIceCandidate
  - Read-only
  - Reference
  - SDP
  - WebRTC
  - WebRTC API
  - ufrag
  - usernameFragment
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The read-only <strong><code>usernameFragment</code></strong> property on the {{domxref("RTCIceCandidate")}} interface is a string indicating the username fragment ("ufrag") that uniquely identifies a single ICE interaction session.</span></p>

<p>This value is specified when creating the {{domxref("RTCIceCandidate")}} by setting the corresponding {{domxref("RTCIceCandidateInit.usernameFragment", "usernameFragment")}} value in the {{domxref("RTCIceCandidateInit")}} object when creating a new candidate with {{domxref("RTCIceCandidate.RTCIceCandidate", "new RTCIceCandidate()")}}. Note that 24 bits of the username fragment are required to be randomized by the browser. See {{anch("Randomization")}} below for details.</p>

<p>If you instead call <code>RTCIceCandidate()</code> with a string parameter containing the <code>candidate</code> m-line text, the value of <code>usernameFragment</code> is extracted from the m-line.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>ufrag</em> = <em>RTCIceCandidate</em>.usernameFragment;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} containing the username fragment (usually referred to in shorthand as "ufrag" or "ice-ufrag") that, along with the ICE password ("ice-pwd"), uniquely identifies a single ongoing ICE interaction, including for any communication with the {{Glossary("STUN")}} server. The string may be up to 256 characters long, and has no default value.</p>

<h4 id="Randomization">Randomization</h4>

<p>At least 24 bits of the text in the <code>ufrag</code> are required to be randomly selected by the ICE layer at the beginning of the ICE session. The specifics for which bits are random and what the remainder of the <code>ufrag</code> text are left up to the browser implementation to decide. For example, a browser might choose to always use a 24-character <code>ufrag</code> in which bit 4 of each character is randomly selected between 0 and 1. Another example: it might take a user-defined string and append three 8-bit random bytes to the end. Or perhaps every character is entirely random.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>ICE uses the <code>usernameFragment</code> and password to ensure message integrity. This avoids crosstalk among multiple ongoing ICE sessions, but, more importantly, helps secure ICE transactions (and all of WebRTC by extension) against attacks that might try to inject themselves into an ICE exchange.</p>

<div class="note">
<p><strong>Note:</strong> There is no API to obtain the ICE password, for what should be fairly obvious security reasons.</p>
</div>

<p>The <code>usernameFragment</code> and password both change every time an <a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime#ICE_restart">ICE restart</a> occurs.</p>

<h2 id="Example">Example</h2>

<p>Although the WebRTC infrastructure will filter out obsolete candidates for you after an ICE restart, you can do it yourself if you're trying to absolutely minimize the number of messages going back and forth.</p>

<p>To do so, you can compare the value of <code>usernameFragment</code> to the current <code>usernameFragment</code> being used for the connection after receiving the candidate from the signaling server and before caling {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} to add it to the set of possible candidates.</p>

<p>When the web app receives a message from the signaling server that includes a candidate to be added to the {{domxref("RTCPeerConnection")}}, you can (and generally <em>should</em>) call <code>addIceCandidate()</code>. There's not typically a need to manually worry about filtering the candidates.</p>

<p>However, let's imagine that we do need to minimize traffic. The function below, <code>ssNewCandidate()</code>, is called when a message, <code>signalMsg</code>, arrives from the signaling server that contains an ICE candidate to be added to the <code>RTCPeerConnection</code>. To avoid including candidates obsoleted by an ICE restart, we can use code like this:</p>

<pre class="brush: js">const ssNewCandidate = signalMsg =&gt; {
  let candidate = new RTCIceCandidate(signalMsg.candidate);
  let receivers = pc.getReceivers();

  receivers.forEach(receiver =&gt; {
    let parameters = receiver.transport.getParameters();

    if (parameters.usernameFragment === candidate.usernameFragment) {
      return;
    }
  });

  pc.addIceCandidate(candidate)
    .catch(reportError);
}
</pre>

<p>This walks through the list of the {{domxref("RTCRtpReceiver")}} objects being used to receive ICE data, and looks to see if the <code>usernameFragment</code> indicated in the candidate matches any of them. If it does, <code>ssNewCandidate()</code> aborts. Otherwise, after checking every receiver, it adds the new candidate to the connection.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicecandidate-usernamefragment', 'RTCIceCandidate.usernameFragment')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate.usernameFragment")}}</p>
</div>
